package com.friday.custody.service.basicService.impl;

import com.friday.custody.entity.DataDictionaryTypeOfSellerDetailsEntity;
import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionaryTypeOfSellerDetailsService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.R;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.friday.custody.utils.PageUtils;
import com.friday.custody.utils.Query;

import com.friday.custody.dao.DataDictionaryTypeOfSellerDao;
import com.friday.custody.entity.DataDictionaryTypeOfSellerEntity;
import com.friday.custody.service.basicService.DataDictionaryTypeOfSellerService;


@Service("dataDictionaryTypeOfSellerService")
public class DataDictionaryTypeOfSellerServiceImpl extends ServiceImpl<DataDictionaryTypeOfSellerDao, DataDictionaryTypeOfSellerEntity>
        implements DataDictionaryTypeOfSellerService, DataDictionaryBasicService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<DataDictionaryTypeOfSellerEntity> page = this.page(
                new Query<DataDictionaryTypeOfSellerEntity>().getPage(params),
                new QueryWrapper<DataDictionaryTypeOfSellerEntity>()
        );

        return new PageUtils(page);
    }

    @Autowired
    private DataDictionaryTypeOfSellerDetailsService detailsService;
    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        HashMap<String, String> result = new HashMap<>();
        List<DataDictionaryTypeOfSellerEntity> allDatas = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(allDatas)) {
            List<DataDictionaryTypeOfSellerDetailsEntity> detailsEntities = detailsService.selectVByTrustNo(trustNo);
            if (!CollectionUtils.isEmpty(detailsEntities)) {
                Map<String, Integer> originValueKeyMap = detailsEntities.stream().collect(Collectors.toMap(DataDictionaryTypeOfSellerDetailsEntity::getOriginValue, DataDictionaryTypeOfSellerDetailsEntity::getDicId));
                Map<Integer, String> idKeyMap = allDatas.stream().collect(Collectors.toMap(DataDictionaryTypeOfSellerEntity::getId, DataDictionaryTypeOfSellerEntity::getKeyStr));
                originValueKeyMap.forEach((originValue, id) -> {
                    result.put(originValue, idKeyMap.get(id));
                });
            } else {
                log.error("DataDictionaryTypeOfSellerDetailsEntity 查询失败！");
            }
        } else {
            log.error("DataDictionaryTypeOfSellerEntity 查询失败！");
        }
        return result;
    }

    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }

    @Override
    public R queryData(String type) {
        List<DataDictionaryTypeOfSellerEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionaryTypeOfSellerEntity::getKeyStr
                            ,DataDictionaryTypeOfSellerEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }
}